package com.sd.business.util.sql;

import com.baomidou.mybatisplus.core.toolkit.support.SFunction;


public class From<T> extends Where<T> {

    private final Sql<T> sql;

    protected From(Sql<T> sql) {
        super(sql);
        this.sql = sql;
    }

    public <K, V> From<T> leftJoin(Class<K> cls1, SFunction<K, ?> on1, SFunction<V, ?> on2) {
        return leftJoin(sql.getTableAlias(cls1), cls1, on1, sql.getTableAlias(on2), on2);
    }

    public <K, V> From<T> leftJoin(Class<K> cls1, SFunction<K, ?> on1, String as2, SFunction<V, ?> on2) {
        return leftJoin(sql.getTableAlias(cls1), cls1, on1, as2, on2);
    }

    public <K, V> From<T> leftJoin(String as1, Class<K> cls1, SFunction<K, ?> on1, SFunction<V, ?> on2) {
        return leftJoin(as1, cls1, on1, sql.getTableAlias(on2), on2);
    }

    public <K, V> From<T> leftJoin(String as1, Class<K> cls1, SFunction<K, ?> on1, String as2, SFunction<V, ?> on2) {
        sql.fromList.add(" LEFT JOIN " + FieldUtil.getTableName(cls1) + " " + as1 + " ON " +
                FieldUtil.getSqlFieldName(as1, on1) + " = " + FieldUtil.getSqlFieldName(as2, on2));
        return this;
    }

    public <K, V> From<T> rightJoin(Class<K> cls1, SFunction<K, ?> on1, SFunction<V, ?> on2) {
        return leftJoin(sql.getTableAlias(cls1), cls1, on1, sql.getTableAlias(on2), on2);
    }

    public <K, V> From<T> rightJoin(Class<K> cls1, SFunction<K, ?> on1, String as2, SFunction<V, ?> on2) {
        return leftJoin(sql.getTableAlias(cls1), cls1, on1, as2, on2);
    }

    public <K, V> From<T> rightJoin(String as1, Class<K> cls1, SFunction<K, ?> on1, SFunction<V, ?> on2) {
        return leftJoin(as1, cls1, on1, sql.getTableAlias(on2), on2);
    }

    public <K, V> From<T> rightJoin(String as1, Class<K> cls1, SFunction<K, ?> on1, String as2, SFunction<V, ?> on2) {
        sql.fromList.add(" RIGHT JOIN " + FieldUtil.getTableName(cls1) + " " + as1 + " ON " +
                FieldUtil.getSqlFieldName(as1, on1) + " = " + FieldUtil.getSqlFieldName(as2, on2));
        return this;
    }

    public <K, V> From<T> innerJoin(Class<K> cls1, SFunction<K, ?> on1, SFunction<V, ?> on2) {
        return leftJoin(sql.getTableAlias(cls1), cls1, on1, sql.getTableAlias(on2), on2);
    }

    public <K, V> From<T> innerJoin(Class<K> cls1, SFunction<K, ?> on1, String as2, SFunction<V, ?> on2) {
        return leftJoin(sql.getTableAlias(cls1), cls1, on1, as2, on2);
    }

    public <K, V> From<T> innerJoin(String as1, Class<K> cls1, SFunction<K, ?> on1, SFunction<V, ?> on2) {
        return leftJoin(as1, cls1, on1, sql.getTableAlias(on2), on2);
    }

    public <K, V> From<T> innerJoin(String as1, Class<K> cls1, SFunction<K, ?> on1, String as2, SFunction<V, ?> on2) {
        sql.fromList.add(" INNER JOIN " + FieldUtil.getTableName(cls1) + " " + as1 + " ON " +
                FieldUtil.getSqlFieldName(as1, on1) + " = " + FieldUtil.getSqlFieldName(as2, on2));
        return this;
    }

}
