package com.sd.business.util.sql;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.baomidou.mybatisplus.core.toolkit.LambdaUtils;
import com.baomidou.mybatisplus.core.toolkit.support.LambdaMeta;
import com.baomidou.mybatisplus.core.toolkit.support.SFunction;
import com.sd.business.util.sql.mapper.JoinMapper;
import lombok.AllArgsConstructor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@AllArgsConstructor
public class Sql<T> {

    protected static final JoinMapper mapper = SpringUtil.getBean(JoinMapper.class);
    protected final Class<T> resultCls;
    protected final List<String> fieldList = new ArrayList<>();
    protected final List<String> fromList = new ArrayList<>();
    private final Map<Class<?>, String> tableAliasMap = new HashMap<>();

    public static <T> Fields<T> create(Class<T> cls) {
        return new Fields<>(new Sql<>(cls));
    }

    protected String getTableAlias(SFunction<?, ?> function) {
        LambdaMeta meta = LambdaUtils.extract(function);
        Class<?> cls = meta.getInstantiatedClass();
        return getTableAlias(cls);
    }

    protected String getTableAlias(LambdaMeta meta) {
        Class<?> cls = meta.getInstantiatedClass();
        return getTableAlias(cls);
    }

    protected String getTableAlias(Class<?> cls) {
        return tableAliasMap.computeIfAbsent(cls, itemCls -> "t" + (tableAliasMap.size() + 1));
    }

    protected String getSql() {
        return "SELECT " + CollectionUtil.join(fieldList, ",") + CollectionUtil.join(fromList, "");
    }

}
